#include "../../../lib/std.mi"

#define ROTATION_LAYER_VAR MyVar
#include "../../../lib/rotationlayer.m"

Function setVolumeLayers(int vpos);
Function rotateByValue(int rpos);
function setvisdsp(int state);

Global Layout MN, MShade;
Global Layer VolLights, LogoLayer, SVolLayer, visClick;
Global Map VolumeMap, ShadeMap;
Global Boolean volClicked=false, ShellState=false, DrawOpen=false, svolClicked=false;
Global AnimatedLayer TrickleCode, ShellLayer, codeVis;
Global Timer DelayT, ReverseTimer;
Global Button OpenShell, LaunchSite, ToggleEQ, ToggleTH, DrawButton;
Global Group EQG, THG, ShadeDraw;
Global Group visGroup, codeGroup, oliGroup;
Global int curVisDsp;


setVolumeLayers(int vpos) {
  VolLights.setRegionFromMap(VolumeMap, vpos, 1);
  rotateByValue(255 - vpos);
}

rotateByValue(int rpos) {
  double npos = (rpos * 360) / 512;
  _MyVarRotateDegree(npos);
}

System.onScriptUnloading() {
  TrickleCode.setAlpha(255);
  LogoLayer.setAlpha(255);
}

System.onScriptLoaded() {

  MN = getContainer("main").getLayout("normal");
  VolLights = MN.getObject("player.volume.lights");
  MShade = getContainer("main").getLayout("shade");
  ShadeDraw = MShade.getObject("group.draw");
  SVolLayer = ShadeDraw.getObject("volume.shade");
  DrawButton = ShadeDraw.getObject("drawtoggle");

  visClick = MN.getObject("visclick");
  visGroup = MN.getObject("visgroup");
  codeGroup = MN.getObject("codegroup");
  codevis = codeGroup.getObject("codevis");
  oliGroup = MN.getObject("oligroup");
  TrickleCode = MN.getObject("code.anim");
  ShellLayer = MN.getObject("shell");
  LogoLayer = MN.getObject("player.main.logo");
  OpenShell = MN.getObject("bb.shell");
  LaunchSite = MN.getObject("wb.site");
  EQG = MN.getObject("group.eq");
  THG = MN.getObject("group.th");
  ToggleTH = MN.getObject("th.toggle");
  ToggleEQ = MN.getObject("eq.toggle");

  EQG.hide();
  THG.hide();

  group volg = MN.getObject("volgroup");

  _MyVarInit(volg, "player.volume.dints");

  VolumeMap = new map;
  VolumeMap.loadMap("main.volume.map");

  ShadeMap = new map;
  ShadeMap.loadMap("shade.vol.map");

  setVolumeLayers(getVolume());
  DelayT = new timer;
  DelayT.setDelay(3000);
  DelayT.start();

  ReverseTimer = new timer;
  ReverseTimer.setDelay(stringtointeger(ShellLayer.getXMLParam("speed")));
  ReverseTimer.stop();
  setvisdsp(getPrivateInt("matrixgame","visdsp",1));
}

system.onPlay() {
 if(curVisDsp==3) codevis.play(); else codevis.stop();
}

system.onResume() {
 if(curVisDsp==3) codevis.play(); else codevis.stop();
}

system.onPause() {
 codevis.stop();
}

system.onStop() {
 codevis.stop();
}

visClick.onLeftButtonUp(int x, int y) {
 int newstate=curVisDsp+1;
 if(newstate>3) newstate=1;
 setvisdsp(newstate);
}

System.onVolumeChanged(int newvol) {
  setVolumeLayers(newvol);
  SVolLayer.setRegionFromMap(ShadeMap, newvol, 1);
}

VolLights.onLeftButtonDown(int x, int y) {
  volClicked = true;
  int nx = x - volLights.getLeft();
  int ny = y - volLights.getTop();
  if (VolumeMap.inRegion(nx,ny)) {
    setVolume(VolumeMap.getValue(nx,ny));
  }
}

VolLights.onLeftButtonUp(int x, int y) {
  volClicked = false;
}

volLights.onMouseMove(int x, int y) {
  if (volClicked) {
    int nx = x - volLights.getLeft();
    int ny = y - volLights.getTop();
    if (VolumeMap.inRegion(nx,ny)) {
      setVolume(VolumeMap.getValue(nx,ny));
    }
  }
}

DelayT.onTimer() {
  TrickleCode.setTargetA(0);
  LogoLayer.setTargetA(0);
  TrickleCode.setTargetSpeed(3);
  LogoLayer.setTargetSpeed(3);
  TrickleCode.gotoTarget();
  LogoLayer.gotoTarget();
  DelayT.stop();
}

TrickleCode.onTargetReached() {
 TrickleCode.stop();
}

OpenShell.onLeftButtonUp(int x, int y) {
  if (ShellState) {
    ShellLayer.stop();
    ReverseTimer.start();
    ShellState = false;
  } else {
    ReverseTimer.stop();
    ShellLayer.setStartFrame(1);
    ShellLayer.play();
    ShellState = true;
  }
}

ShellLayer.onFrame(int frame) {
  if (frame == ShellLayer.getEndFrame()) {
     ShellLayer.stop();
     return;
  }
  if (frame == ShellLayer.getStartFrame()) {
    ReverseTimer.stop();
  }
}

ReverseTimer.onTimer() {
  ShellLayer.gotoFrame(ShellLayer.getCurFrame() - 1);
}

LaunchSite.onLeftButtonUp(int x, int y) {
  navigateUrl(getParam());
}

ToggleTH.onLeftButtonUp(int x, int y) {
  if (THG.isVisible())  {
    THG.hide();
    EQG.hide();
  } else {
    THG.show();
    EQG.hide();
  }
}

ToggleEQ.onLeftButtonUp(int x, int y) {
  if (EQG.isVisible())  {
    EQG.hide();
    EQG.hide();
  } else {
    EQG.show();
    THG.hide();
  }
}

DrawButton.onLeftButtonUp(int x, int y) {
  if (!DrawOpen) {
    ShadeDraw.setTargetY(32);
  } else {
     ShadeDraw.setTargetY(11);
  }

  DrawOpen = !DrawOpen;

  ShadeDraw.setTargetSpeed(1);
  ShadeDraw.gotoTarget();
}

SVolLayer.onLeftButtonDown(int x, int y) {
  svolClicked = true;
}

SVolLayer.onLeftButtonUp(int x, int y) {
  svolClicked = false;
}

SVolLayer.onMouseMove(int x, int y) {
  if (svolClicked) {
    int nx = x - SVolLayer.getLeft();
    int ny = y - SVolLayer.getTop();
    if (ShadeMap.inRegion(nx,ny)) {
      setVolume(ShadeMap.getValue(nx,ny));
      SVolLayer.setRegionFromMap(ShadeMap, ShadeMap.getValue(nx,ny), 1);
    }
  }
}

setvisdsp(int state){
 if(state==1) {
  visGroup.show();
  codeGroup.hide();
  oligroup.hide();
  codevis.stop();
 }
 if(state==2) {
  oligroup.show();
  visGroup.hide();
  codeGroup.hide();
  codevis.stop();
 }
 if(state==3) {
  codeGroup.show();
  visGroup.hide();
  oligroup.hide();
  if(getStatus()==STATUS_PLAYING) codevis.play(); else codevis.stop();
 }
 curVisDsp=state;
 setPrivateInt("matrixgame","visdsp",curVisDsp);
}